# -*- coding: UTF-8 -*-
import re
import json


def get_tags():
    return ['4', '4.9']


def run_task(runcontext):
    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params, "chdir", None)
    runcontext.set_mod_params_instance(ansible_params, "executable", None)

    module = runcontext.get_module_file("shell.py")
    rc, out = run_audit(runcontext, ansible_params, module)
    return rc, out


def run_audit(runcontext, ansible_params, module):
    curtemplate = runcontext.get_template()
    ret_code = -1
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"

    tmp_vars["checkresult1"] = "failed"
    tmp_vars["scancommand1"] = '''ps -wef | grep "ftpd" | grep -v grep'''
    tmp_vars["systemvalue1"] = ""

    tmp_vars["checkresult2"] = "failed"
    tmp_vars["scancommand2"] = '''data=`if [ -f /etc/vsftpd/vsftpd.conf ]; then printf '/etc/vsftpd/vsftpd.conf'; else if [ -f /etc/vsftpd.conf ]; then printf '/etc/vsftpd.conf';fi;fi;`; if [ ! -z "$data" ]; then grep -v "^[[:space:]]*#" $data | awk -F'#' '{print $1}' | grep '^[[:space:]]*anonymous_enable' 2>/dev/null;fi '''
    tmp_vars["systemvalue2"] = ""

    tmp_vars["checkresult3"] = "failed"
    tmp_vars["scancommand3"] = '''data=`if [ -f /etc/vsftpd/vsftpd.conf ]; then printf '/etc/vsftpd/vsftpd.conf'; else if [ -f /etc/vsftpd.conf ]; then printf '/etc/vsftpd.conf';fi;fi;`; if [ ! -z "$data" ]; then grep -v "^[[:space:]]*#" $data | awk -F'#' '{print $1}' | grep '^[[:space:]]*anon_upload_enable' 2>/dev/null;fi '''
    tmp_vars["systemvalue3"] = ""

    tmp_vars["checkresult4"] = "failed"
    tmp_vars["scancommand4"] = '''data=`if [ -f /etc/vsftpd/vsftpd.conf ]; then printf '/etc/vsftpd/vsftpd.conf'; else if [ -f /etc/vsftpd.conf ]; then printf '/etc/vsftpd.conf';fi;fi;`; if [ ! -z "$data" ]; then grep -v "^[[:space:]]*#" $data | awk -F'#' '{print $1}' | grep '^[[:space:]]*anon_mkdir_write_enable' 2>/dev/null;fi '''
    tmp_vars["systemvalue4"] = ""

    tmp_vars["checkresult5"] = "failed"
    tmp_vars["scancommand5"] = '''data=`if [ -f /etc/vsftpd/vsftpd.conf ]; then printf '/etc/vsftpd/vsftpd.conf'; else if [ -f /etc/vsftpd.conf ]; then printf '/etc/vsftpd.conf';fi;fi;`; if [ ! -z "$data" ]; then grep -v "^[[:space:]]*#" $data | awk -F'#' '{print $1}' | grep '^[[:space:]]*deny_email_enable' 2>/dev/null;fi'''
    tmp_vars["systemvalue5"] = ""

    tmp_vars["checkresult6"] = "failed"
    tmp_vars["scancommand6"] = '''unset data;unset securecat;unset ret;data=`if [ -f /etc/vsftpd/vsftpd.conf ]; then printf '/etc/vsftpd/vsftpd.conf'; else if [ -f /etc/vsftpd.conf ]; then printf '/etc/vsftpd.conf';fi;fi;`; securecat=`if [ ! -z "$data" ]; then cat $data | grep -v "^[[:space:]]*#" | awk -F'#' '{print $1}' | grep '^[[:space:]]*banned_email_file' | awk -F'=' '{print $2}' 2>/dev/null;fi`;if [ ! -z "$securecat" ];then ret=`find $securecat -type f 2>/dev/null`;if [ ! -z "$ret" ];then echo $ret;fi;fi;unset securecat;unset ret; '''
    tmp_vars["systemvalue6"] = ""

    tmp_vars["checkresult7"] = "failed"
    tmp_vars["scancommand7"] = '''data=`if [ -f /etc/pure-ftpd/pure-ftpd.conf ]; then printf '/etc/pure-ftpd/pure-ftpd.conf'; else if [ -f /etc/pure-ftpd.conf ]; then printf '/etc/pure-ftpd.conf';fi;fi;`; if [ ! -z "$data" ]; then egrep -v "^[[:space:]]*#|^[[:space:]]*$" $data | egrep -i "NoAnonymous";fi;unset data; '''
    tmp_vars["systemvalue7"] = ""

    tmp_vars["checkresult8"] = "failed"
    tmp_vars["scancommand8"] = r'''data=`if [ -f /etc/ftpaccess ]; then printf '/etc/ftpaccess'; else if [ -f /etc/ftpd/ftpaccess ]; then printf '/etc/ftpd/ftpaccess';fi;fi;`; if [ ! -z "$data" ]; then grep -v "^[[:space:]]*#" $data | egrep "^class\s*.*(guest|anonymous).*" 2>/dev/null;else echo "ftpaccess does not exist";fi; '''
    tmp_vars["systemvalue8"] = ""

    tmp_vars["checkresult9"] = "failed"
    tmp_vars["scancommand9"] = r'''data=`if [ -f /etc/proftpd.conf ]; then printf '/etc/proftpd.conf'; else if [ -f /etc/proftpd/proftpd.conf ]; then printf '/etc/proftpd/proftpd.conf';fi;fi;`; if [ ! -z "$data" ]; then Anonymous_1=`cat $data|sed '/^[[:space:]]*#/d'|sed '/^[[:space:]]*$/d'|sed -n '/<Anonymous.*/,/<\/Anonymous>/p'|grep -i "AnonRequirePassword[[:space:]]*on"`;Anonymous_2=`cat $data|sed '/^[[:space:]]*#/d'|sed '/^[[:space:]]*$/d'|sed -n '/<Anonymous.*/,/<\/Anonymous>/p'`;if ([ -n "$Anonymous_1" ] || [ -z "$Anonymous_2" ]);then printf "true";fi;fi; '''
    tmp_vars["systemvalue9"] = ""

    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand1"])
    arc1, astdout1, astderr1 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(arc1, astdout1, astderr1)
    runcontext.sleep()

    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand2"])
    arc2, astdout2, astderr2 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(arc2, astdout2, astderr2)
    runcontext.sleep()

    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand3"])
    arc3, astdout3, astderr3 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(arc3, astdout3, astderr3)
    runcontext.sleep()

    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand4"])
    arc4, astdout4, astderr4 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(arc4, astdout4, astderr4)
    runcontext.sleep()

    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand5"])
    arc5, astdout5, astderr5 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(arc5, astdout5, astderr5)
    runcontext.sleep()

    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand6"])
    arc6, astdout6, astderr6 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(arc6, astdout6, astderr6)
    runcontext.sleep()

    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand7"])
    arc7, astdout7, astderr7 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(arc7, astdout7, astderr7)
    runcontext.sleep()

    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand8"])
    arc8, astdout8, astderr8 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(arc8, astdout8, astderr8)
    runcontext.sleep()

    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand9"])
    arc9, astdout9, astderr9 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(arc9, astdout9, astderr9)
    runcontext.sleep()

    if arc1 != 0:
        return (-2, "Failed to invoke module: %s." % astdout1)
    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]
    astderr1 = resultjson1["stderr"]
    match1 = re.match(r"^\s*$", astdout1)
    tmp_vars["systemvalue1"] = astdout1
    if match1:
        tmp_vars["checkresult1"] = "pass"

    if arc2 != 0:
        return (-2, "Failed to invoke module: %s." % astdout2)
    resultjson2 = json.loads(astdout2)
    astdout2 = resultjson2["stdout"]
    astderr2 = resultjson2["stderr"]
    match2 = re.match(r"^\s*anonymous_enable\s*=\s*NO", astdout2)
    tmp_vars["systemvalue2"] = astdout2
    if match2:
        tmp_vars["checkresult2"] = "pass"

    if arc3 != 0:
        return (-2, "Failed to invoke module: %s." % astdout3)
    resultjson3 = json.loads(astdout3)
    astdout3 = resultjson3["stdout"]
    astderr3 = resultjson3["stderr"]
    match3 = re.match(r"^\s*anon_upload_enable\s*=\s*YES", astdout3)
    tmp_vars["systemvalue3"] = astdout3
    if match3 is None:
        tmp_vars["checkresult3"] = "pass"

    if arc4 != 0:
        return (-2, "Failed to invoke module: %s." % astdout4)
    resultjson4 = json.loads(astdout4)
    astdout4 = resultjson4["stdout"]
    astderr4 = resultjson4["stderr"]
    match4 = re.match(r"^\s*anon_mkdir_write_enable\s*=\s*YES", astdout4)
    tmp_vars["systemvalue4"] = astdout4
    if match4 is None:
        tmp_vars["checkresult4"] = "pass"

    if arc5 != 0:
        return (-2, "Failed to invoke module: %s." % astdout5)
    resultjson5 = json.loads(astdout5)
    astdout5 = resultjson5["stdout"]
    astderr5 = resultjson5["stderr"]
    match5 = re.match(r"^\s*deny_email_enable\s*=\s*YES", astdout5)
    tmp_vars["systemvalue5"] = astdout5
    if match5:
        tmp_vars["checkresult5"] = "pass"

    if arc6 != 0:
        return (-2, "Failed to invoke module: %s." % astdout6)
    resultjson6 = json.loads(astdout6)
    astdout6 = resultjson6["stdout"]
    astderr6 = resultjson6["stderr"]
    match6 = re.match(r".+", astdout6)
    tmp_vars["systemvalue6"] = astdout6
    if match6:
        tmp_vars["checkresult6"] = "pass"

    if arc7 != 0:
        return (-2, "Failed to invoke module: %s." % astdout7)
    resultjson7 = json.loads(astdout7)
    astdout7 = resultjson7["stdout"]
    astderr7 = resultjson7["stderr"]
    match7 = re.match(r"^\s*NoAnonymous\s+yes", astdout7)
    tmp_vars["systemvalue7"] = astdout7
    if match7:
        tmp_vars["checkresult7"] = "pass"

    if arc8 != 0:
        return (-2, "Failed to invoke module: %s." % astdout8)
    resultjson8 = json.loads(astdout8)
    astdout8 = resultjson8["stdout"]
    astderr8 = resultjson8["stderr"]
    match8 = re.match(r"^\s*$", astdout8)
    tmp_vars["systemvalue8"] = astdout8
    if match8:
        tmp_vars["checkresult8"] = "pass"

    if arc9 != 0:
        return (-2, "Failed to invoke module: %s." % astdout9)
    resultjson9 = json.loads(astdout9)
    astdout9 = resultjson9["stdout"]
    astderr9 = resultjson9["stderr"]
    match9 = re.match(r"true", astdout9)
    tmp_vars["systemvalue9"] = astdout9
    if match9:
        tmp_vars["checkresult9"] = "pass"

    if tmp_vars["checkresult1"] == "pass" or tmp_vars["checkresult2"] == "pass" or (tmp_vars["checkresult2"] == "failed" and tmp_vars["checkresult3"] == "pass" and tmp_vars["checkresult4"] == "pass" and tmp_vars["checkresult5"] == "pass" and tmp_vars["checkresult6"] == "pass") or tmp_vars["checkresult7"] == "pass" or tmp_vars["checkresult8"] == "pass" or tmp_vars["checkresult9"] == "pass":
        ret_code = 0
        tmp_vars["policyresult"] = "pass"

    rc, out = curtemplate.render(runcontext.get_template_file('t_4_9.j2'), **tmp_vars)

    if rc == False:
        return (-2, "Failed to render template.%s" % out)

    return ret_code, out
